/*
* Title:	PhaseTableWin.h
* Author:	M.Thomas BEAM Ltd
* Date:		2007-04-03
*
* Contents:	Pupe Simulation mode setup
*
* Mod Rec:
*
*/

#ifndef PHASETABLEWIN_H
#define PHASETABLEWIN_H

#include <BString.h>
#include <qhbox.h>
#include <Control.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include <qtextedit.h>
#include <qlistbox.h>
#include <qtable.h>


#include <TmsD.h>
#include <TmsC.h>
#include <TmsS.h>
#include <TmsLib.h>

/*! Configure System and setup user interface window. 
*
*/

class PhaseTableWin : public QWidget {
        Q_OBJECT
public:
        PhaseTableWin(QWidget* w,Control& c);
	~PhaseTableWin();

public slots:
	void	show();

private slots:
	void    update(); 
	BError  updateControlList(); 
	void    updateCycleInfo(); 
	void	selectFile();

	void	loadFromFile();
	void	loadFromTms();
	void	saveFile();
	void	upload();

	void	loadCycleParams();
	void	addOffsets();
	void	loadDefaults();
	
private:
	void		setParams();
	BString		uIntToStr(UInt32 v);
	
	void		warningDialog(BString title, BError err);
	int		confirmDialog(BString title, BString msg);

	Control&		ocontrol;
	
	QLineEdit*		ocycleType;
	QLineEdit*		oinfo;
	QLineEdit*		opllInitialFrequency;
	QLineEdit*		opllInitialFrequencyDelay;
	QLineEdit*		opllFrefGain;
	QLineEdit*		opllGain;

	QSpinBox*		ooffset;

	QLineEdit*		ofilename;

	QPushButton*		oselectFile;
	QPushButton*		oloadFromFile;
	QPushButton*		oloadFromTms;

	
	QPushButton*		oupload;
	QPushButton*		osaveFile;
	QPushButton*		oloadDefaults;
	QPushButton*		oaddOffsets;
	
	QListBox*		ocycleTypes;
	QTable*			ophaseDelays;
	
	Tms::CycleParam		oparams;

};
#endif
